
namespace IRDB_SDK
{
	using namespace std;

	class pqxxDB_t : virtual public DBinterface_t
	{
		protected:
			pqxxDB_t() {}
			pqxxDB_t(const pqxxDB_t& copy) = delete;
		public:
			virtual ~pqxxDB_t() { };

			virtual void         issueQuery(string query)         = 0;
			virtual void         issueQuery(stringstream & query) = 0;
			virtual void         moveToNextRow()                  = 0;
			virtual string       getResultColumn(string colname)  = 0;
			virtual bool         isDone()                         = 0;
			virtual void         commit()                         = 0;
			virtual pqxx::connection&  
				             getConnection()                  = 0; 
			virtual pqxx::work&  getTransaction()                 = 0; 

			static unique_ptr<pqxxDB_t> factory();

	};
}
