namespace IRDB_SDK
{
	using namespace std;
	class TransformStep_t
	{
		protected:
			TransformStep_t() { }
		public:
			virtual        ~TransformStep_t(void) { } 

			virtual string getStepName(void) const = 0;

			virtual int    parseArgs(const vector<string> step_args)      = 0;
			virtual int    executeStep(IRDBObjects_t *const irdb_objects) = 0;
	};

}


// Must also declare a getTransformStep global function in your thanos-enabled .so file
// so that thanos can use it as a factory to create your transform class.  It must
// follow this signature:
//
// extern "C" std::shared_ptr<TransformStep_t> getTransformStep(void);    


