
namespace IRDB_SDK
{
	using namespace std;

	class Relocation_t : virtual public BaseObj_t
	{
		protected:
			Relocation_t() { }
			Relocation_t(const Relocation_t& copy) = delete;
		
		public:
			virtual ~Relocation_t() { }

			virtual int        getOffset() const = 0;
			virtual string     getType()   const = 0;
			virtual uint32_t   getAddend() const = 0;
			virtual BaseObj_t* getWRT()    const = 0;

			virtual void setOffset(int off)              = 0;
			virtual void setType(string ty)              = 0;
			virtual void setAddend(uint32_t p_addend)    = 0;
			virtual void setWRT(BaseObj_t* WRT)          = 0;

	};
}
